module calculator(

	input				clk_in,			//ⲿʱ룬STEP FPGAC1
	input				rst_n_in,		//ϵͳλӦSTEP FPGA尴L14
	output	[2:0]		scl_out,		//I2C SCLSTEP FPGAC8
	inout	[2:0]		sda_out,		//I2C SDASTEP FPGAB8
	input               uart_in,
	output              uart_out,	
	output	[7:0]		led_out,		//ӦSTEP FPGA8LED
	output 	[8:0] 		segment_led_1,  //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
	output 	[8:0] 		segment_led_2,   //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
	
	output lcd_rst_out,
	output lcd_cs_out,  // chip select, active low
	output lcd_dc_out,  // data or command control
	output lcd_clk_out,  // clock
	output lcd_data_out, // data
	output led
);

assign led = 0;
wire clk_pll;

wire [7:0] sensor_data1;
wire [7:0] sensor_data2;
wire [3:0] sensor_data3;
wire  [8:0] key_operate_pulse;
wire  [10:0] key_num_pulse;
cap1298_top cap1298_top_u
(
    .clk_in(clk_in),			//ⲿʱ룬STEP FPGAC1
    .rst_n_in(rst_n_in),		//ϵͳλӦSTEP FPGA尴L14
    .scl_out(scl_out),		//I2C SCLSTEP FPGAC8
    .sda_out(sda_out),		//I2C SDASTEP FPGAB8  
	.key_operate_pulse(key_operate_pulse),
    .key_num_pulse(key_num_pulse),
    .led_out(led_out),		//ӦSTEP FPGA8LED
    .segment_led_1(segment_led_1),  //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
    .segment_led_2(segment_led_2)   //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
);
wire [3:0] lcd_gpioPIO_OUT;
wire lcd_sdaPIO_OUT,lcd_sckPIO_OUT;

assign uart_out = uart_tx_rx;
/*
mico8_top mico8_top_u ( 
.clk_i(clk_in),
.reset_n(rst_n_in)
, .uartSIN(uart_tx_rx) // 
, .uartSOUT() //
, .lcd_gpioPIO_OUT(lcd_gpioPIO_OUT) // [4-1:0]
, .lcd_sdaPIO_OUT(lcd_sdaPIO_OUT) // [1-1:0]
, .lcd_sckPIO_OUT(lcd_sckPIO_OUT) // [1-1:0]
);
*/
assign lcd_cs_out = lcd_gpioPIO_OUT[0]; // chip select, active low
assign lcd_rst_out = lcd_gpioPIO_OUT[1];
assign lcd_dc_out = lcd_gpioPIO_OUT[2];  // data or command control
assign lcd_clk_out = lcd_sckPIO_OUT;  // clock
assign lcd_data_out = lcd_sdaPIO_OUT;  // data

wire uart_tx_rx;
wire uart_tx_valid;
wire [7:0] uart_data;
wire uart_tx_en;

compute compute_u(
.clk_in(clk_in),
.rst_n_in(rst_n_in),
.uart_tx_valid(uart_tx_valid),
.key_operate_pulse(key_operate_pulse),
.key_num_pulse(key_num_pulse),
.uart_tx_en(uart_tx_en),
.uart_data(uart_data)

);

/////////////////////////////////uart_tx module////////////////////////////////////
wire bps_clk_tx,bps_en;

Baud #
(
.BPS_PARA				(104		)
)
Baud_tx
(
.clk_in					(clk_in			),	// 12MHz system clock
.rst_n_in				(rst_n_in		),	// system reset, active low
.bps_en					(1'b1			),	// start beat request
.bps_clk				(bps_clk_tx		)	// data receive beat for 9600 bps
);

Uart_Tx Uart_Tx_u
(
.clk_in					(clk_in			),	// 12MHz system clock
.rst_n_in				(rst_n_in		),	// system reset, active low
.bps_en					(bps_en			),	// beat clock enable
.bps_clk				(bps_clk_tx		),	// beat clock input
.uart_tx_en             (uart_tx_en     ),
.rx_bps_en				(bps_clk_tx	    ),	// 
.tx_data				(uart_data   ),	// data need to transfer
.rs232_tx				(uart_tx_rx		),	// uart transfer pin
.uart_tx_valid 			(uart_tx_valid	)	// 1:indicate tx done ,0:transfering,can't send new data to it 
);

/*
/////////////////////////////////uart_rx module////////////////////////////////////
wire					bps_en_rx,bps_clk_rx;
wire			[7:0]	rx_data;

Baud #
(
.BPS_PARA				(104		)
)
Baud_rx
(	
.clk_in					(clk_in			),	// 12MHz system clock
.rst_n_in				(rst_n_in		),	// system reset, active low
.bps_en					(bps_en_rx		),	// start beat request
.bps_clk				(bps_clk_rx		)	// data receive beat for 9600 bps
);

Uart_Rx Uart_Rx_uut
(
.clk_in					(clk_in			),	// 12MHz system clock
.rst_n_in				(rst_n_in		),	// system reset, active low
.bps_en					(bps_en_rx		),	// beat clock enable
.bps_clk				(bps_clk_rx		),	// beat clock input
.rs232_rx				(uart_in		),	// uart receive pin
.rx_data				(rx_data		)	// data of uart receive
);
//reg [7:0] rx_data_reg;
//always rx_data_reg = rx_data;

*/

endmodule

