// --------------------------------------------------------------------
// >>>>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<
// --------------------------------------------------------------------
// Module: pianoshield_top
// 
// Author: Step
// 
// Description: pianoshield top module
//	
// Web: www.stepfpga.com
// 
// --------------------------------------------------------------------
// Code Revision History :
// --------------------------------------------------------------------
// Version: |Mod. Date:   |Changes Made:
// V1.0     |2017/06/5   |Initial ver
// --------------------------------------------------------------------
module cap1298_top(
	input				clk_in,			//ⲿʱ룬STEP FPGAC1
	input				rst_n_in,		//ϵͳλӦSTEP FPGA尴L14
	output	[2:0]		scl_out,		//I2C SCLSTEP FPGAC8
	inout	[2:0]		sda_out,		//I2C SDASTEP FPGAB8
    
    
    output  [8:0]       key_operate_pulse,	//һʱڵ
    output  [10:0]      key_num_pulse,		//һʱڵ
	output	[7:0]		led_out,		//ӦSTEP FPGA8LED
	output 	[8:0] 		segment_led_1,  //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
	output 	[8:0] 		segment_led_2   //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
    
);

//cap1188ĶӦֵ,ÿcap11888·Ӧ8:8'h01,8'h04,8'h10,8'h20,8'h40,8'h80ûаʱ0
wire 	[7:0]	sensor_data1;
wire 	[7:0]	sensor_data2;
wire 	[7:0]	sensor_data3;
reg 	[7:0] 	touch_data;
//cap1298_i2cģͨI2CCAP1298ͨţǰֵ
cap1298_i2c		cap1298_i2c_u1
(
	.clk_in					(clk_in		 ),
	.rst_n_in				(rst_n_in	 ),
	.scl_out				(scl_out[0]	 ),
	.sda_out				(sda_out[0]	 ),
	.sensor_data			(sensor_data1)
);
/*
cap1298_i2c		cap1298_i2c_u2
(
	.clk_in					(clk_in		 ),
	.rst_n_in				(rst_n_in	 ),
	.scl_out				(scl_out[1]	 ),
	.sda_out				(sda_out[1]	 ),
	.sensor_data			(sensor_data2)
);

cap1298_i2c		cap1298_i2c_u3
(
	.clk_in					(clk_in		 ),
	.rst_n_in				(rst_n_in	 ),
	.scl_out				(scl_out[2]	 ),
	.sda_out				(sda_out[2]	 ),
	.sensor_data			(sensor_data3)
);
*/
parameter	CNT_NUM = 19'd240_000;
reg [8:0] key_operate;					//bit 8:0 Ӧ -- AC,+-,%,/,X,+,=,C
reg [10:0] key_num;						//bit 10:0 Ӧ 0 1 2 3 4 5 6 7 8 9 . 
always@( posedge clk_in  or  negedge rst_n_in )
begin
	if(!rst_n_in) begin
        key_num <= 0;	//11'b111_1111_1111;
        key_operate <= 0;	//9'b1_1111_1111;
        
	end else if(sensor_data1) begin
				case(sensor_data1)
				8'h01:key_num[9]    <=1'b1;    //2'b0000_0001 S1
				8'h02:key_operate[6]<=1'b1;//2'b0000_0010 S2 
				8'h04:key_operate[5]<=1'b1;//2'b0000_0100 S3
				8'h08:key_operate[4]<=1'b1;//2'b0000_1000 S4
				8'h10:key_operate[3]<=1'b1;//2'b0001_0000 S5
				8'h20:key_operate[2]<=1'b1;//2'b0010_0000 S6
				8'h40:key_operate[1]<=1'b1;//2'b0100_0000 S7
				8'h80:key_num[6]    <=1'b1;    //2'b1000_0000 S8	
				default:begin key_num <= 0; key_operate <= 0;end
				endcase
			end else if(sensor_data2) begin
				case(sensor_data2)
				8'h01:key_operate[0]<=1'b1;//2'b0000_0001 S9
				8'h02:key_num[3]    <=1'b1;//2'b0000_0010 S10
				8'h04:key_num[10]   <=1'b1;//2'b0000_0100 S11
				8'h08:key_num[2]    <=1'b1;//2'b0000_1000 S12
				8'h10:key_num[5]    <=1'b1;//2'b0001_0000 S13
				8'h20:key_num[8]    <=1'b1;//2'b0010_0000 S14
				8'h40:key_operate[7]<=1'b1;//2'b0100_0000 S15
				8'h80:key_operate[8]<=1'b1;//2'b1000_0000 S16	
				default:begin key_num <= 0; key_operate <= 0;end
				endcase
			end else if(sensor_data3)begin
				case(sensor_data3)
				8'h01:key_num[7]<=1'b1;//2'b0000_0001 S17
				8'h02:key_num[4]<=1'b1;//2'b0000_0010 S18
				8'h04:key_num[1]<=1'b1;//2'b0000_0100 S19
				8'h08:key_num[0]<=1'b1;//2'b0000_1000 S20
				default:begin key_num <= 0; key_operate <= 0;end
				endcase				
			end else begin
				key_num <= 0;//11'b111_1111_1111;
				key_operate <= 0;//9'b1_1111_1111;
			end
		
end

reg [10:0] num_status_r,num_status = 0;//11'b111_1111_1111;
//wire [10:0] key_num_pulse;
always@( posedge clk_in  or  negedge rst_n_in )
begin
	if (!rst_n_in) begin 
        num_status_r <= 0;//11'b111_1111_1111;
        num_status <= 0;//11'b111_1111_1111;
    end else begin 
        num_status <= key_num;
        num_status_r <= num_status;
    end
end		
//ʱһʱӵĸߵƽ壬ư
assign key_num_pulse = num_status & ( ~num_status_r);

reg [8:0] operate_status_r,operate_status = 0;//9'b1_1111_1111;
//wire [8:0] key_operate_pulse;
always@( posedge clk_in  or  negedge rst_n_in )
begin
	if (!rst_n_in) begin 
        operate_status_r <= 0;//9'b1_1111_1111;
        operate_status <= 0;//9'b1_1111_1111;
    end else begin 
        operate_status <= key_operate;
        operate_status_r <= operate_status;
    end
end		
//ʱһʱӵĸߵƽ壬ư
assign key_operate_pulse = operate_status & ( ~operate_status_r);
/*
reg[18:0]  count;
reg [10:0] num_status_r,num_status;
reg [8:0] operate_status_r,operate_status;
always @ (posedge clk_in  or negedge rst_n_in)
    if (!rst_n_in) count <= 19'd0;
    else if(count >= CNT_NUM-1) count <=19'd0;
    else count <= count + 1'b1;
	
//Lock the status to register low_sw when cnt count to 19'd500000(20ms)
always @(posedge clk_in  or  negedge rst_n_in)
    if (!rst_n_in) begin 
		num_status <= 11'b111_1111_1111;
		operate_status <= 9'b1_1111_1111;
	end else if (count == CNT_NUM-1) begin
		operate_status <= key_operate;
        num_status <= key_num;
	end 

always@( posedge clk_in  or  negedge rst_n_in )
begin
	if (!rst_n_in) begin 
        num_status_r <= 11'b111_1111_1111;   
		operate_status_r <= 9'b1_1111_1111;
    end else begin        
        num_status_r <= num_status;
		operate_status_r <= operate_status;
    end
end		


//ʱһʱӵĸߵƽ壬ư
assign key_num_pulse = num_status & ( ~num_status_r);

assign key_operate_pulse = operate_status & ( ~operate_status_r);

*/
assign led_out = ~(sensor_data3 |sensor_data2 |sensor_data1);

reg	[7:0]	cnt;
//count for key_pulse
always @(posedge clk_in  or negedge rst_n_in) begin
	if(!rst_n_in) cnt <= 8'h00;
	else if(key_num_pulse) begin
                case(key_num_pulse)
                    11'b000_0000_0001:begin cnt[3:0] <= 0;end//0
                    11'b000_0000_0010:begin cnt[3:0] <= 1;end//1
                    11'b000_0000_0100:begin cnt[3:0] <= 2;end//2
                    11'b000_0000_1000:begin cnt[3:0] <= 3;end//3
                    11'b000_0001_0000:begin cnt[3:0] <= 4;end//4
                    11'b000_0010_0000:begin cnt[7:4] <= 5;end//5
                    11'b000_0100_0000:begin cnt[7:4] <= 6;end//6
                    11'b000_1000_0000:begin cnt[7:4] <= 7;end//7
                    11'b001_0000_0000:begin cnt[7:4] <= 8;end//8
                    11'b010_0000_0000:begin cnt[7:4] <= 9;end//9
                    11'b100_0000_0000:begin cnt[7:4] <= 0;end//.
                default:;
                endcase  
    /*
		if(cnt>=8'h99) begin
			cnt <= 8'h0;
		end else if(cnt[3:0]>=4'd9) begin
			cnt[3:0] <= 4'd0;
			cnt[7:4] <= cnt[7:4] + 1'b1;
		end else begin
			cnt[3:0] <= cnt[3:0] + 1'b1;
		end
        */
	end
end

//segment led display module
display		display_u
(	.rst_n_in(rst_n_in),
	.sensor_data_1(cnt[7:4]),  //seg_data input
	.sensor_data_2(cnt[3:0]),  //seg_data input
	.segment_led_1(segment_led_1),  //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
	.segment_led_2(segment_led_2)   //MSB~LSB = SEG,DP,G,F,E,D,C,B,A
);



endmodule
