#ifndef __SYSTEM_CONFIG_H_
#define __SYSTEM_CONFIG_H_


#define FPGA_DEVICE_FAMILY    "MachXO2"
#define PLATFORM_NAME         "mico8"
#define USE_PLL               (0)
#define CPU_FREQUENCY         (12000000)


/* FOUND 1 CPU UNIT(S) */

/*
 * CPU Instance LM8 component configuration
 */
#define CPU_NAME "LM8"

/*
 * lcd_gpio component configuration
 */
#define LCD_GPIO_NAME  "lcd_gpio"
#define LCD_GPIO_BASE_ADDRESS  (0x80000000)
#define LCD_GPIO_SIZE  (16)
#define LCD_GPIO_CHARIO_IN        (0)
#define LCD_GPIO_CHARIO_OUT       (0)
#define LCD_GPIO_WB_DAT_WIDTH  (8)
#define LCD_GPIO_WB_ADR_WIDTH  (4)
#define LCD_GPIO_ADDRESS_LOCK  (0)
#define LCD_GPIO_DISABLE  (0)
#define LCD_GPIO_OUTPUT_PORTS_ONLY  (1)
#define LCD_GPIO_INPUT_PORTS_ONLY  (0)
#define LCD_GPIO_TRISTATE_PORTS  (0)
#define LCD_GPIO_BOTH_INPUT_AND_OUTPUT  (0)
#define LCD_GPIO_DATA_WIDTH  (4)
#define LCD_GPIO_INPUT_WIDTH  (1)
#define LCD_GPIO_OUTPUT_WIDTH  (1)
#define LCD_GPIO_IRQ_MODE  (0)
#define LCD_GPIO_LEVEL  (0)
#define LCD_GPIO_EDGE  (0)
#define LCD_GPIO_EITHER_EDGE_IRQ  (0)
#define LCD_GPIO_POSE_EDGE_IRQ  (0)
#define LCD_GPIO_NEGE_EDGE_IRQ  (0)

/*
 * lcd_sda component configuration
 */
#define LCD_SDA_NAME  "lcd_sda"
#define LCD_SDA_BASE_ADDRESS  (0x80000010)
#define LCD_SDA_SIZE  (16)
#define LCD_SDA_CHARIO_IN        (0)
#define LCD_SDA_CHARIO_OUT       (0)
#define LCD_SDA_WB_DAT_WIDTH  (8)
#define LCD_SDA_WB_ADR_WIDTH  (4)
#define LCD_SDA_ADDRESS_LOCK  (0)
#define LCD_SDA_DISABLE  (0)
#define LCD_SDA_OUTPUT_PORTS_ONLY  (1)
#define LCD_SDA_INPUT_PORTS_ONLY  (0)
#define LCD_SDA_TRISTATE_PORTS  (0)
#define LCD_SDA_BOTH_INPUT_AND_OUTPUT  (0)
#define LCD_SDA_DATA_WIDTH  (1)
#define LCD_SDA_INPUT_WIDTH  (1)
#define LCD_SDA_OUTPUT_WIDTH  (1)
#define LCD_SDA_IRQ_MODE  (0)
#define LCD_SDA_LEVEL  (0)
#define LCD_SDA_EDGE  (0)
#define LCD_SDA_EITHER_EDGE_IRQ  (0)
#define LCD_SDA_POSE_EDGE_IRQ  (0)
#define LCD_SDA_NEGE_EDGE_IRQ  (0)

/*
 * lcd_sck component configuration
 */
#define LCD_SCK_NAME  "lcd_sck"
#define LCD_SCK_BASE_ADDRESS  (0x80000020)
#define LCD_SCK_SIZE  (16)
#define LCD_SCK_CHARIO_IN        (0)
#define LCD_SCK_CHARIO_OUT       (0)
#define LCD_SCK_WB_DAT_WIDTH  (8)
#define LCD_SCK_WB_ADR_WIDTH  (4)
#define LCD_SCK_ADDRESS_LOCK  (0)
#define LCD_SCK_DISABLE  (0)
#define LCD_SCK_OUTPUT_PORTS_ONLY  (1)
#define LCD_SCK_INPUT_PORTS_ONLY  (0)
#define LCD_SCK_TRISTATE_PORTS  (0)
#define LCD_SCK_BOTH_INPUT_AND_OUTPUT  (0)
#define LCD_SCK_DATA_WIDTH  (1)
#define LCD_SCK_INPUT_WIDTH  (1)
#define LCD_SCK_OUTPUT_WIDTH  (1)
#define LCD_SCK_IRQ_MODE  (0)
#define LCD_SCK_LEVEL  (0)
#define LCD_SCK_EDGE  (0)
#define LCD_SCK_EITHER_EDGE_IRQ  (0)
#define LCD_SCK_POSE_EDGE_IRQ  (0)
#define LCD_SCK_NEGE_EDGE_IRQ  (0)

/*
 * uart component configuration
 */
#define UART_NAME  "uart"
#define UART_BASE_ADDRESS  (0x80000030)
#define UART_SIZE  (16)
#define UART_IRQ (0)
#define UART_CHARIO_IN        (1)
#define UART_CHARIO_OUT       (1)
#define UART_CHARIO_TYPE      "RS-232"
#define UART_ADDRESS_LOCK  (0)
#define UART_DISABLE  (0)
#define UART_MODEM  (0)
#define UART_WB_DAT_WIDTH  (8)
#define UART_WB_ADR_WIDTH  (4)
#define UART_BAUD_RATE  (115200)
#define UART_IB_SIZE  (4)
#define UART_OB_SIZE  (4)
#define UART_BLOCK_WRITE  (1)
#define UART_BLOCK_READ  (1)
#define UART_STDOUT_SIM  (0)
#define UART_STDOUT_SIMFAST  (0)
#define UART_RXRDY_ENABLE  (0)
#define UART_TXRDY_ENABLE  (0)
#define UART_INTERRUPT_DRIVEN  (1)
#define UART_LCR_DATA_BITS  (8)
#define UART_LCR_STOP_BITS  (1)
#define UART_LCR_PARITY_ENABLE  (0)
#define UART_LCR_PARITY_ODD  (0)
#define UART_LCR_PARITY_STICK  (0)
#define UART_LCR_SET_BREAK  (0)
#define UART_FIFO  (0)


#endif /* __SYSTEM_CONFIG_H_ */
