#include "MicoUtils.h"
#include "DDStructs.h"
#include "MicoGPIO.h"
#include "MicoUart.h"
#include "LCD_Driver.h"
/***************************************************************
 * TEMPLATE SPECIFIC PARAMETERS ARE HERE, CHANGE AS NEEDED.    *
 ***************************************************************/
MicoUartCtx_t *uart = &uart_core_uart;
MicoGPIOCtx_t *lcd_gpio  = &gpio_lcd_gpio;
MicoGPIOCtx_t *lcd_sda  = &gpio_lcd_sda;
MicoGPIOCtx_t *lcd_sck  = &gpio_lcd_sck;
unsigned char lcd_charcount=0;
unsigned char lcd_charnum[10]={};

//unsigned int  cal_value1,cal_value2,cal_value_done=0;
//unsigned char cal_number[10]={};
//unsigned char cal_num_count = 0;// count of value number for value1 and value2
unsigned char cal_value2_flag = 0;// input value2 flag 
unsigned char cal_compute_done = 0;
unsigned char cal_compute_Receive = 0;


//char *WELCOME_MSG = "-- Initialize OK --\r\n";

unsigned char characterdata[14][16]={
{0xE0,0x10,0x08,0x08,0x08,0x08,0x10,0xE0,0x07,0x08,0x10,0x10,0x10,0x10,0x08,0x07},//0
{0x00,0x20,0x30,0x10,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x00,0x00,0x00},//1
{0x20,0x10,0x08,0x08,0x08,0x08,0x90,0x70,0x10,0x18,0x14,0x12,0x12,0x11,0x10,0x10},//2
{0x10,0x08,0x08,0x88,0x88,0x88,0xD0,0x70,0x08,0x10,0x10,0x10,0x10,0x10,0x09,0x07},//3
{0x00,0x00,0x80,0x40,0x20,0xF8,0x00,0x00,0x06,0x05,0x04,0x04,0x04,0x1F,0x04,0x04},//4
{0xE0,0xF8,0x48,0x48,0x48,0x48,0x88,0x08,0x08,0x10,0x10,0x10,0x10,0x10,0x08,0x07},//5
{0xE0,0xB0,0x98,0x88,0x88,0x88,0x08,0x10,0x07,0x09,0x10,0x10,0x10,0x10,0x09,0x0F},//6
{0x08,0x08,0x08,0x08,0x88,0x68,0x18,0x08,0x00,0x00,0x18,0x07,0x00,0x00,0x00,0x00},//7
{0x70,0xD8,0x88,0x88,0x88,0x88,0xD0,0x70,0x0F,0x09,0x10,0x10,0x10,0x10,0x09,0x0F},//8
{0xF0,0x90,0x08,0x08,0x08,0x08,0x90,0xE0,0x08,0x10,0x11,0x11,0x11,0x19,0x0D,0x07},//9

{0x00,0x00,0x00,0x00,0xE0,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x07,0x01,0x01,0x01},//+
{0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00},//-
{0x00,0x20,0x40,0x80,0x00,0x80,0x60,0x20,0x00,0x08,0x04,0x03,0x01,0x06,0x08,0x00},//x
{0x00,0x00,0x00,0x80,0x60,0x10,0x0C,0x00,0x30,0x0C,0x02,0x01,0x00,0x00,0x00,0x00} ///

};

/***************************************************************
 * Send String to the Uart									   *
 **************************************************************
void SendString (MicoUartCtx_t *pUart, char *str)
{
	char *ptr = str;
	do {
		MicoUart_putC (pUart, *ptr);
		ptr++;
	} while (*ptr != '\0');	
}
*/
void LCD_Display(unsigned char page,unsigned char* charnum,unsigned char count_num)
{
    unsigned char i,display_num;
    for(i=0;i<count_num;i++)
    {
        display_num=charnum[count_num-1-i];//0-13
        display_graphic_8x16(page,123-8*i,&characterdata[display_num][0]);
    }
}
/*
static void compute(unsigned int value1,unsigned int value2,unsigned char compute_char)
{
    unsigned char i;
	switch(compute_char)
	{
		case '+':cal_value_done = value1 + value2; break;
		case '-':if(cal_value2!=0)cal_value_done = value1 - value2; break;
		case '*':cal_value_done = value1 * value2; break;
		case '/':cal_value_done = value1 / value2; break;
		default: ;break;
	}
    i = 0;
    while (1)
    {
        cal_number[i] = cal_value_done % 10;
        cal_value_done = cal_value_done / 10;
        i++;
        if (cal_value_done == 0) break;
    }
}

*/
    unsigned char row1_charcount,row2_charcount=0;
    unsigned char row1_charnum[10]={};
    unsigned char row2_charnum[10]={};

int main (void)
{
	char key_value;
	unsigned char i,key_num=0;
    unsigned char operateChar;
    MicoGPIOInit (lcd_gpio);
    MicoGPIOInit (lcd_sda);
    MicoGPIOInit (lcd_sck);

	initial_lcd();
	//MicoUartInit(uart);
	clear_screen();
    /*
	for(i=0;i<14;i++)
	{
		display_graphic_8x16(0,3+i*8,&characterdata[i][0]);
	}
    */
	//SendString (uart, WELCOME_MSG);
	key_value =0;
    cal_compute_done =0;
    cal_value2_flag =0;
    cal_compute_Receive = 0;
	while (1)
	{
		//MicoSleepMilliSecs(400);
		MicoUart_getC (uart, &key_value);     
		//MicoUart_putC (uart,key_value);
		if(key_value != 0)
		{
			if(key_value=='0'||key_value=='1'||key_value=='2'||key_value=='3'||key_value=='4'||key_value=='5'||key_value=='6'||key_value=='7'||key_value=='8'||key_value=='9'||key_value=='$')
			{
				switch(key_value)
				{
					case '0':key_num = 0;break;
					case '1':key_num = 1;break;
					case '2':key_num = 2;break;
					case '3':key_num = 3;break;
					case '4':key_num = 4;break;
					case '5':key_num = 5;break;
					case '6':key_num = 6;break;
					case '7':key_num = 7;break;
					case '8':key_num = 8;break;
					case '9':key_num = 9;break;
					default: ;break;
				}
                if(cal_compute_done)
                {                   	
                    if(key_value=='$')
                    {
                    	clear_screen();
                    	if(cal_compute_Receive)
                    	{
							cal_compute_Receive = 0;
							LCD_Display(2,row2_charnum,row2_charcount);
                    	}else{
                    		row2_charnum[0] = 0;
                    		LCD_Display(2,row2_charnum,1);
                    	}
                        cal_compute_done = 0;

                        for(i=0;i<10;i++)
                        {
                           row1_charnum[i] = 0;
                           row2_charnum[i] = 0;
                        }
                        row1_charcount = 0;
                        row2_charcount = 0;
                    }else{

                        //if(row2_charcount >= 10)
                        //	row2_charcount = 0;

                        if(key_num != 0)
                        	cal_compute_Receive = 1;

                        if(cal_compute_Receive)
                        {
                        	row2_charnum[row2_charcount++] = key_num;
                        }

                    }
                   
                }else{
                        if(!cal_value2_flag)
                        {
                            //if(row1_charcount >= 10)
                            //row1_charcount = 0;
                            row1_charnum[row1_charcount++] = key_num;
                            clear_screen();
                            LCD_Display(0,row1_charnum,row1_charcount);
                            

                        }else if(cal_value2_flag==1){
                            //if(row2_charcount >= 10)
                           // row2_charcount = 0;
                            row2_charnum[row2_charcount++] = key_num;
                            LCD_Display(2,row2_charnum,row2_charcount);
                        }                   
                }
			}
			else if(key_value=='+'||key_value=='-'||key_value=='*'||key_value=='/')
			{
				switch(key_value)
				{
					case '+':key_num = 10; operateChar = 1;break;
					case '-':key_num = 11; operateChar = 2;break;
					case '*':key_num = 12; operateChar = 3;break;
					case '/':key_num = 13; operateChar = 4;break;
					default: ;break;
				}
	            cal_value2_flag = 1;
                row2_charcount = 0;
	           // if(row1_charcount >= 10)
	           //     row1_charcount = 0;
	            row1_charnum[row1_charcount++] = key_num;
				//MicoUart_putC (uart,key_num);
                clear_screen();
	            LCD_Display(0,row1_charnum,row1_charcount);
			}
			else if(key_value == '=')
			{
	            operateChar = 5;
	            cal_value2_flag = 0;
                cal_compute_done = 1;
                row2_charcount = 0;
				//MicoUart_putC (uart,key_value);
				//compute(cal_value1,cal_value2,operateChar);

	           // LCD_Display(2,cal_number,cal_num_count);
			}
			else if(key_value == 'A')
			{
				//MicoUart_putC (uart,key_value);
                    cal_compute_done = 0;
                    cal_value2_flag = 0;
	            key_value =0;
	            for(i=0;i<10;i++)
	            {
	               row1_charnum[i] = 0;
	               row2_charnum[i] = 0;
	            }
	            row1_charcount = 0;
	            row2_charcount = 0;
				clear_screen();

			}
	        else if(key_value == 'C')
			{
				//MicoUart_putC (uart,key_value);
	            key_value =0;
				clear_screen();
			}


		}//end of if(key_value != 0)

	}//end of while
		
	return 0;
}//end of main

